#pragma semicolon 1
#include <multicolors>

#undef REQUIRE_PLUGIN
#undef REQUIRE_EXTENSIONS
#tryinclude <myjailbreak>
#tryinclude <lastrequest>
#define REQUIRE_EXTENSIONS
#define REQUIRE_PLUGIN

#pragma newdecls required
#include <sdktools>
#include <shop>

public Plugin myinfo =
{
	name        = 	"[Shop] Jetpack",
	author      = 	"vadrozh & FrozDark",
	version     = 	"1.7",
	url         = 	"http://hlmod.ru/"
};

ItemId g_iID;
bool g_bDelay[MAXPLAYERS+1], g_bInUse[MAXPLAYERS+1], g_bEffects;
float g_fReloadDelay, g_fBoost;
int g_iMax, g_iJumps[MAXPLAYERS+1], g_iPrice, g_iSellPrice, g_iItemTime;
Handle g_hTimer[MAXPLAYERS+1];
ConVar g_hPrice, g_hSellPrice, g_hTime, g_hReloadDelay, g_hMax, g_hBoost, g_hEffects;

//----------------------------------INITILIZATION--------------------------------

public void OnPluginStart()
{
	LoadTranslations("shop_jetpack.phrases");
	
	(g_hPrice = CreateConVar("sm_shop_jetpack_price", "3000", "Цена покупки.", _, true, 0.0)).AddChangeHook(ChangeCvar_Buy);
	(g_hSellPrice = CreateConVar("sm_shop_jetpack_sell_price", "300", "Цена продажи.", _, true, 0.0)).AddChangeHook(ChangeCvar_Sell);
	(g_hTime = CreateConVar("sm_shop_jetpack_time", "14400", "Время действия покупки в секундах.", _, true, 0.0)).AddChangeHook(ChangeCvar_Time);
	(g_hReloadDelay = CreateConVar("sm_shop_jetpack_reloadtime", "300.0", "Сколько секунд нужно для перезарядки ранца.", 0, true, 1.0)).AddChangeHook(ChangeCvar_ReloadTime);
	(g_hBoost = CreateConVar("sm_shop_jetpack_boost", "380.0", "Сила подъема ракетного ранца(мин. 400).", 0, true, 400.0)).AddChangeHook(ChangeCvar_Boost);
	(g_hMax = CreateConVar("sm_shop_jetpack_max", "3", "Сколько секунд можно использовать ранец.", 0, true, 0.0)).AddChangeHook(ChangeCvar_Max);
	(g_hEffects = CreateConVar("sm_shop_jetpack_effects", "1", "Создавать эффект джетпака?", 0, true, 1.0)).AddChangeHook(ChangeCvar_Effects);
	
	OnConfigsExecuted();
	if (Shop_IsStarted()) Shop_Started();
	
	AutoExecConfig(true, "shop_jetpack", "shop");
}

public void OnPluginEnd(){Shop_UnregisterMe();}

public void OnClientDisconnect(int iClient)
{
	g_iJumps[iClient] = 0;
	g_bDelay[iClient] = false;
	g_bInUse[iClient] = false;
	if (g_hTimer[iClient])
		g_hTimer[iClient] = INVALID_HANDLE;
}

public void OnConfigsExecuted()
{
	g_iPrice = g_hPrice.IntValue;
	if (g_iID) Shop_SetItemPrice(g_iID, g_iPrice);
	g_iSellPrice = g_hSellPrice.IntValue;
	if (g_iID) Shop_SetItemSellPrice(g_iID, g_iSellPrice);
	g_iItemTime = g_hTime.IntValue;
	if (g_iID) Shop_SetItemValue(g_iID, g_iItemTime);
	g_iMax = g_hMax.IntValue*10;
	g_fBoost = g_hBoost.FloatValue;
	g_fReloadDelay = g_hReloadDelay.FloatValue;
	g_bEffects = g_hEffects.BoolValue;
}

//------------------------------------CVAR CHANGED---------------------------------------

public void ChangeCvar_Buy(ConVar convar, const char[] oldValue, const char[] newValue)
{
    g_iPrice = convar.IntValue;
    if (g_iID) Shop_SetItemPrice(g_iID, g_iPrice);
}

public void ChangeCvar_Sell(ConVar convar, const char[] oldValue, const char[] newValue)
{
    g_iSellPrice = convar.IntValue;
    if (g_iID) Shop_SetItemSellPrice(g_iID, g_iSellPrice);
}

public void ChangeCvar_Time(ConVar convar, const char[] oldValue, const char[] newValue)
{
    g_iItemTime = convar.IntValue;
    if (g_iID) Shop_SetItemValue(g_iID, g_iItemTime);
}

public void ChangeCvar_Max(ConVar convar, const char[] oldValue, const char[] newValue){g_iMax = convar.IntValue*10;}
public void ChangeCvar_Boost(ConVar convar, const char[] oldValue, const char[] newValue){g_fBoost = convar.FloatValue;}
public void ChangeCvar_ReloadTime(ConVar convar, const char[] oldValue, const char[] newValue){g_fReloadDelay = convar.FloatValue;}
public void ChangeCvar_Effects(ConVar convar, const char[] oldValue, const char[] newValue){g_bEffects = convar.BoolValue;}

//-------------------------------------SHOP SETTINGS-----------------------------

public void Shop_Started()
{
    CategoryId category_id = Shop_RegisterCategory("ability", "Способности", "");
    if (Shop_StartItem(category_id, "shop_jetpack"))
    {
        Shop_SetInfo("Jetpack", "Press SPACE+CTRL to activate", g_iPrice, g_iSellPrice, Item_Togglable, g_iItemTime);
        Shop_SetCallbacks(OnItemRegistered, OnEquipItem, _, OnDisplay, OnDisplayDescription, _, _, OnSell);
        Shop_EndItem();
    }
}
 
public void OnItemRegistered(CategoryId category_id, const char[] sCategory, const char[] sItem, ItemId item_id) { g_iID = item_id;}
 
public bool OnDisplay(int iClient, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, ShopMenu menu, bool &disabled, const char[] sName, char[] sBuffer, int iMaxlen)
{
    FormatEx(sBuffer, iMaxlen, "%T", "Jetpack", iClient);
    return true;
}
 
public bool OnDisplayDescription(int iClient, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, ShopMenu menu, const char[] sDescription, char[] sBuffer, int iMaxlen)
{
    FormatEx(sBuffer, iMaxlen, "%T", "JetpackDesc", iClient);
    return true;
}

public ShopAction OnEquipItem(int iClient, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, bool isOn, bool elapsed)
{
	if (isOn || elapsed)
	{
		g_bInUse[iClient] = false;
		return Shop_UseOff;
	}

	g_bInUse[iClient] = true;
	return Shop_UseOn;
}

public bool OnSell(int iClient, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, ItemType type, int iSellPrice)
{
	OnClientDisconnect(iClient);
	return true;
}

//----------------------------------------JETPACK-------------------------------------

public Action OnPlayerRunCmd(int iClient, int &iButtons, int &iImpulse)
{
	if (!IsPlayerAlive(iClient) || !IsClientInGame(iClient) || g_bDelay[iClient] || !g_bInUse[iClient] || !iButtons || (GetEntityMoveType(iClient) & MOVETYPE_LADDER))
		return Plugin_Continue;
	
	if (iButtons & IN_JUMP && iButtons & IN_DUCK)
	{
		if (g_iJumps[iClient] <= g_iMax)
		{
			if (g_iMax)
				g_iJumps[iClient]++;
	
			float ClientEyeAngle[3], ClientAbsOrigin[3], Velocity[3];
			GetClientEyeAngles(iClient, ClientEyeAngle);
			GetClientAbsOrigin(iClient, ClientAbsOrigin);
			ClientEyeAngle[0] = -40.0;
			GetAngleVectors(ClientEyeAngle, Velocity, NULL_VECTOR, NULL_VECTOR);
			ScaleVector(Velocity, g_fBoost);
			TeleportEntity(iClient, NULL_VECTOR, NULL_VECTOR, Velocity);
			
			if (g_bEffects)
				CreateEffect(iClient, ClientAbsOrigin, ClientEyeAngle);
			
			g_bDelay[iClient] = true;
			if (g_iJumps[iClient] >= g_iMax && g_fReloadDelay)
			{
				g_hTimer[iClient] = CreateTimer(g_fReloadDelay, Reload, iClient);
				CPrintToChat(iClient, "%t %t", "Prefix", "JetpackEmpty");
			} else
				CreateTimer(0.1, DelayOff, iClient);
		}
	}
	
	return Plugin_Continue;
}

//-------------------------------------JETPACK EFFECT-------------------------

public void CreateEffect(int iClient, float vecorigin[3], float vecangle[3])
{
	vecangle[0] = 110.0;
	vecorigin[2] += 25.0;
	
	int iEffect[2];
	char tName[32], fire_name[32];
	
	FormatEx(tName, sizeof(tName), "target%i", iClient);
	DispatchKeyValue(iClient, "targetname", tName);
	
	for (int i = 0; i<1; ++i)
	{
		iEffect[i] = CreateEntityByName("env_steam");
		if (iEffect[i] != -1)
		{
			FormatEx(fire_name, sizeof(fire_name), "fire%i%i", i, iClient);
			DispatchKeyValue(iEffect[i],"targetname", fire_name);
			DispatchKeyValue(iEffect[i],"parentname", tName);
			DispatchKeyValue(iEffect[i],"SpawnFlags", "1");
			DispatchKeyValue(iEffect[i],"InitialState", "1");
			DispatchKeyValue(iEffect[i],"Spreadspeed", "10");
			DispatchKeyValue(iEffect[i],"Speed", "400");
			DispatchKeyValue(iEffect[i],"Startsize", "20");
			DispatchKeyValue(iEffect[i],"EndSize", "600");
			DispatchKeyValue(iEffect[i],"JetLength", "200");
			if(i)
			{
				DispatchKeyValue(iEffect[1],"Type", "1");
				DispatchKeyValue(iEffect[1],"Rate", "10");
				DispatchKeyValue(iEffect[i],"RenderColor", "255 100 30");
				DispatchKeyValue(iEffect[i],"RenderAmt", "180");
			} else {
				DispatchKeyValue(iEffect[i],"Type", "0");
				DispatchKeyValue(iEffect[i],"Rate", "30");
			}
			DispatchSpawn(iEffect[i]);
			TeleportEntity(iEffect[i], vecorigin, vecangle, NULL_VECTOR);
			SetVariantString(tName);
			AcceptEntityInput(iEffect[i], "SetParent", iEffect[i], iEffect[i], 0);
			AcceptEntityInput(iEffect[i], "TurnOn");
		}
	}
	
	Handle hEffectPack = CreateDataPack();
	WritePackCell(hEffectPack, iEffect[0]);
	WritePackCell(hEffectPack, iEffect[1]);
	CreateTimer(0.8, Killfire, hEffectPack);
}

//-----------------------------------TIMERS--------------------------------

public Action Killfire(Handle timer, Handle hEffectPack)
{
	if (hEffectPack)
	{
		int iEffect[2], i;
		char sClassname[16];
		ResetPack(hEffectPack);
		iEffect[0] = ReadPackCell(hEffectPack);
		iEffect[1] = ReadPackCell(hEffectPack);
		CloseHandle(hEffectPack);
		
		for (i=0; i<1; ++i)
		{
			if (IsValidEntity(iEffect[i]))
			{
				AcceptEntityInput(iEffect[i], "TurnOff");
				GetEdictClassname(iEffect[i], sClassname, sizeof(sClassname));
				if (!strcmp(sClassname, "env_steam", false))
				RemoveEdict(iEffect[i]);
			}
		}
	}
}

public Action DelayOff(Handle timer, int iClient) { g_bDelay[iClient] = false;}

public Action Reload(Handle timer, int iClient)
{
	if (g_hTimer[iClient] != INVALID_HANDLE)
	{
		g_iJumps[iClient] = 0;
		g_bDelay[iClient] = false;
		if (IsClientInGame(iClient))
			CPrintToChat(iClient, "%t %t", "Prefix", "JetpackReloaded");
		g_hTimer[iClient] = INVALID_HANDLE;
	}
}